## ardour3 3.5.403~dfsg

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys

def fetch_git_revision ():
    cmd = "git describe HEAD"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode ('utf-8')
    return rev

def fetch_tarball_revision ():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print 'This tarball was not created correctly - it is missing libs/ardour/revision.cc'
        sys.exit (1)
    with open('libs/ardour/revision.cc') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')
        return content[1].decode('utf-8').strip().split(' ')[7].translate (remove_punctuation_map)

if os.path.isdir (os.path.join(os.getcwd(), '.git')):
    rev = fetch_git_revision ()
else:
    rev = fetch_tarball_revision ()

#
# rev is now of the form MAJOR.MINOR-rev-commit
#

parts = rev.split ('.')
MAJOR = parts[0]
other = parts[1].split ('-')
MINOR = other[0]
MICRO = other[1]

V = MAJOR + '.' + MINOR + '.' + MICRO
#
# it is important that VERSION *not* be unicode string
# because if it is, it breaks waf somehow.
#
VERSION = V.encode ('ascii', 'ignore')
APPNAME = 'Ardour' + MAJOR

# Mandatory variables
top = '.'
out = 'build'

children = [
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/vamp-sdk',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/taglib',
        'libs/libltc',
        'libs/rubberband',
        'libs/surfaces',
        'libs/panners',
        'libs/backends',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/clearlooks-newer',
        'libs/audiographer',
        'libs/plugins/reasonablesynth.lv2',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'patchfiles'
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

if sys.platform == 'linux2':
    children += [ 'tools/sanity_check' ]
    lxvst_default = True
elif sys.platform == 'darwin':
    children += [ 'libs/appleutility' ]
    lxvst_default = False
else:
    lxvst_default = False

# Version stuff

def fetch_gcc_version (CC):
    cmd = "LANG= %s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("Git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        #
        # if you change the format of this, be sure to fix fetch_tarball_revision() above
        # so that  it still works.
        #
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #

    build_host_supports_sse = False

    # Flags necessary for building
    compiler_flags = []     # generic
    c_flags = []            # C-specific
    cxx_flags = []          # C++-specific
    linker_flags = []

    # Optimization flags (overridable)
    optimization_flags = []

    # Debugging flags
    debug_flags = []

    u = os.uname ()
    cpu = u[4]
    platform = u[0].lower()
    version = u[2]

    # waf adds -O0 -g itself. thanks waf!
    is_clang = conf.env['CXX'][0].endswith('clang++')
    
    if conf.options.cxx11:
        conf.check_cxx(cxxflags=["-std=c++11"])
        cxx_flags.append('-std=c++11')
        if platform == "darwin":
            cxx_flags.append('-stdlib=libc++')
            link_flags.append('-lc++')
            # Prevents visibility issues in standard headers
            conf.define("_DARWIN_C_SOURCE", 1)

    if conf.options.asan:
        conf.check_cxx(cxxflags=["-fsanitize=address", "-fno-omit-frame-pointer"], linkflags=["-fsanitize=address"])
        cxx_flags.append('-fsanitize=address')
        cxx_flags.append('-fno-omit-frame-pointer')
        linker_flags.append('-fsanitize=address')

    if is_clang and platform == "darwin":
        # Silence warnings about the non-existing osx clang compiler flags
        # -compatibility_version and -current_version.  These are Waf
        # generated and not needed with clang
        cxx_flags.append("-Qunused-arguments")
        
    if opt.gprofile:
        debug_flags = [ '-pg' ]

    # Autodetect
    if opt.dist_target == 'auto':
        if platform == 'darwin':
            # The [.] matches to the dot after the major version, "." would match any character
            if re.search ("^[0-7][.]", version) != None:
                conf.env['build_target'] = 'panther'
            elif re.search ("^8[.]", version) != None:
                conf.env['build_target'] = 'tiger'
            elif re.search ("^9[.]", version) != None:
                conf.env['build_target'] = 'leopard'
            elif re.search ("^10[.]", version) != None:
                conf.env['build_target'] = 'snowleopard'
            elif re.search ("^11[.]", version) != None:
                conf.env['build_target'] = 'lion'
            else:
                conf.env['build_target'] = 'mountainlion'
        else:
            match = re.search(
                    "(?P<cpu>i[0-6]86|x86_64|powerpc|ppc|ppc64|arm|s390x?)",
                    cpu)
            if (match):
                conf.env['build_target'] = match.group("cpu")
                if re.search("i[0-5]86", conf.env['build_target']):
                    conf.env['build_target'] = "i386"
            else:
                conf.env['build_target'] = 'none'
    else:
        conf.env['build_target'] = opt.dist_target

    if conf.env['build_target'] == 'snowleopard':
        #
        # stupid OS X 10.6 has a bug in math.h that prevents llrint and friends
        # from being visible.
        # 
        compiler_flags.append ('-U__STRICT_ANSI__')

    if cpu == 'powerpc' and conf.env['build_target'] != 'none':
        #
        # Apple/PowerPC optimization options
        #
        # -mcpu=7450 does not reliably work with gcc 3.*
        #
        if opt.dist_target == 'panther' or opt.dist_target == 'tiger':
            if platform == 'darwin':
                # optimization_flags.extend ([ "-mcpu=7450", "-faltivec"])
                # to support g3s but still have some optimization for above
                compiler_flags.extend ([ "-mcpu=G3", "-mtune=7450"])
            else:
                compiler_flags.extend ([ "-mcpu=7400", "-maltivec", "-mabi=altivec"])
        else:
            compiler_flags.extend([ "-mcpu=750", "-mmultiple" ])
        compiler_flags.extend (["-mhard-float", "-mpowerpc-gfxopt"])
        optimization_flags.extend (["-Os"])

    elif ((re.search ("i[0-9]86", cpu) != None) or (re.search ("x86_64", cpu) != None)) and conf.env['build_target'] != 'none':


        #
        # ARCH_X86 means anything in the x86 family from i386 to x86_64
        # the compile-time presence of the macro _LP64 is used to 
        # distingush 32 and 64 bit assembler
        #

        if (re.search ("(i[0-9]86|x86_64)", cpu) != None):
            compiler_flags.append ("-DARCH_X86")

        if platform == 'linux' :

            #
            # determine processor flags via /proc/cpuinfo
            #

            if conf.env['build_target'] != 'i386':

                flag_line = os.popen ("cat /proc/cpuinfo | grep '^flags'").read()[:-1]
                x86_flags = flag_line.split (": ")[1:][0].split ()

                if "mmx" in x86_flags:
                    compiler_flags.append ("-mmmx")
                if "sse" in x86_flags:
                    build_host_supports_sse = True
                if "3dnow" in x86_flags:
                    compiler_flags.append ("-m3dnow")

            if cpu == "i586":
                compiler_flags.append ("-march=i586")
            elif cpu == "i686":
                compiler_flags.append ("-march=i686")

        if not is_clang and ((conf.env['build_target'] == 'i686') or (conf.env['build_target'] == 'x86_64')) and build_host_supports_sse:
            compiler_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])

    # end of processor-specific section

    # optimization section
    if conf.env['FPU_OPTIMIZATION']:
        if sys.platform == 'darwin':
            compiler_flags.append("-DBUILD_VECLIB_OPTIMIZATIONS");
            linker_flags.append("-framework Accelerate")
        elif conf.env['build_target'] == 'i686' or conf.env['build_target'] == 'x86_64':
            compiler_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
        if not build_host_supports_sse:
            print("\nWarning: you are building Ardour with SSE support even though your system does not support these instructions. (This may not be an error, especially if you are a package maintainer)")

    # end optimization section

    #
    # no VST on x86_64
    #

    if conf.env['build_target'] == 'x86_64' and opt.windows_vst:
        print("\n\n==================================================")
        print("You cannot use VST plugins with a 64 bit host. Please run waf with --windows-vst=0")
        print("\nIt is theoretically possible to build a 32 bit host on a 64 bit system.")
        print("However, this is tricky and not recommended for beginners.")
        sys.exit (-1)

    if opt.lxvst:
        if conf.env['build_target'] == 'x86_64':
            compiler_flags.append("-DLXVST_64BIT")
        else:
            compiler_flags.append("-DLXVST_32BIT")

    #
    # a single way to test if we're on OS X
    #

    if conf.env['build_target'] in ['panther', 'tiger', 'leopard', 'snowleopard' ]:
        conf.define ('IS_OSX', 1)
        # force tiger or later, to avoid issues on PPC which defaults
        # back to 10.1 if we don't tell it otherwise.

        compiler_flags.extend(
                ("-DMAC_OS_X_VERSION_MIN_REQUIRED=1040",
                 '-mmacosx-version-min=10.4'))

    elif conf.env['build_target'] in [ 'lion', 'mountainlion' ]:
        compiler_flags.extend(
                ("-DMAC_OS_X_VERSION_MIN_REQUIRED=1070",
                 '-mmacosx-version-min=10.7'))
    else:
        conf.define ('IS_OSX', 0)

    #
    # save off CPU element in an env
    #
    conf.define ('CONFIG_ARCH', cpu)

    #
    # ARCH="..." overrides all
    #

    if opt.arch != None:
        optimization_flags = opt.arch.split()

    #
    # prepend boiler plate optimization flags that work on all architectures
    #

    optimization_flags[:0] = ["-pipe"]

    # don't prepend optimization flags if "-O<something>" is present
    prepend_opt_flags = True
    for flag in optimization_flags:
        if flag.startswith("-O"):
            prepend_opt_flags = False
            break

    if prepend_opt_flags:
        optimization_flags[:0] = [
                "-O3",
                "-fomit-frame-pointer",
                "-ffast-math",
                "-fstrength-reduce"
                ]

    if opt.stl_debug:
        cxx_flags.append("-D_GLIBCXX_DEBUG")

    if conf.env['DEBUG_RT_ALLOC']:
        compiler_flags.append('-DDEBUG_RT_ALLOC')
        linker_flags.append('-ldl')

    if conf.env['DEBUG_DENORMAL_EXCEPTION']:
        compiler_flags.append('-DDEBUG_DENORMAL_EXCEPTION')
