=== midi_maps/wscript ===
#!/usr/bin/python

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):
    maps = bld.path.ant_glob ('*.map')
    bld.install_files (os.path.join(bld.env['DATADIR'], 'ardour3', 'midi_maps'),
                       maps)

def options(opt):
    pass
