=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import subprocess
import sys

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 3001

# Variables for 'waf dist'
APPNAME = 'libardour3'
I18N_PACKAGE = 'ardour3'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'async_midi_port.cc',
        'audio_buffer.cc',
        'audio_diskstream.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'backend_search_path.cc',
        'beats_frames_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'configuration.cc',
        'config_text.cc',
        'control_protocol_manager.cc',
        'control_protocol_search_path.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delivery.cc',
        'directory_names.cc',
        'diskstream.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'engine_slave.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_formats_search_path.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_slave.cc',
        'lv2_bundled_search_path.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_clock_slave.cc',
        'midi_diskstream.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_patch_search_path.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'midiport_manager.cc',
        'mix.cc',
        'monitor_processor.cc',
        'mtc_slave.cc',
        'mtdm.cc',
        'mute_master.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_search_path.cc',
        'panner_shell.cc',
        'pcm_utils.cc',
        'pi_controller.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'port.cc',
        'port_insert.cc',
        'port_manager.cc',
        'port_set.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'recent_sessions.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'send.cc',
        'session.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'slave.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'srcfilesource.cc',
        'strip_silence.cc',
        'revision.cc',
        'tape_file_matcher.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'version.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.build_version_files(
        path_prefix + 'ardour/version.h',
        path_prefix + 'version.cc',
        'libardour3', conf.env['MAJOR'], conf.env['MINOR'], 0)
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                      atleast_version='0.4.0')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')

    if re.search ("linux", sys.platform) != None:
        autowaf.check_pkg(conf, 'alsa', uselib_store='ALSA')

    if Options.options.lv2:
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                          atleast_version='1.0.0', mandatory=True)
        autowaf.check_pkg(conf, 'lv2', uselib_store='NEW_LV2',
                          atleast_version='1.0.15', mandatory=False)
        autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                          atleast_version='0.8.0', mandatory=True)
        autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                          atleast_version='0.2.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='NEW_LILV',
                          atleast_version='0.15.0', mandatory=False)
        autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                          atleast_version='0.6.0', mandatory=False)
        conf.define ('LV2_SUPPORT', 1)

#    autowaf.check_pkg(conf, 'soundtouch-1.0', uselib_store='SOUNDTOUCH',
#                      mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    # we don't try to detect this, since its part of our source tree

    conf.define('HAVE_RUBBERBAND', 1) # controls whether we think we have it
    conf.define('USE_RUBBERBAND', 1)  # controls whether we actually use it

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')


def build(bld):
    # Library version (UNIX style major, minor, micro)
    # major increment <=> incompatible changes
    # minor increment <=> compatible changes (additions)
    # micro increment <=> no interface changes
    LIBARDOUR_LIB_VERSION = "3.0.0."

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=libardour_sources)
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=libardour_sources)
        obj.cxxflags     = [ '-fPIC' ]
        obj.cflags       = [ '-fPIC' ]

    obj.export_includes = ['.']
    obj.includes     = ['.', '../surfaces/control_protocol', '..']
    obj.name         = 'ardour'
    obj.target       = 'ardour'
    obj.uselib       = ['GLIBMM','GTHREAD','AUBIO','SIGCPP','XML','UUID',
                        'SNDFILE','SAMPLERATE','LRDF','AUDIOUNITS',
                        'OSX','BOOST','CURL','DL']
    obj.use          = ['libpbd','libmidipp','libevoral','libvampplugin',
                        'libaudiographer','libltc','libtimecode']
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        obj.uselib.extend(['RUBBERBAND', 'TAGLIB', 'LIBLTC', 'VAMPSDK',
                           'VAMPHOSTSDK'])
    else:
        obj.use.extend(['libltc', 'librubberband', 'libtaglib', 'libvamphost'])

    obj.vnum         = LIBARDOUR_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines      = [
        'PACKAGE="' + I18N_PACKAGE + '"',
        'DATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
