=== debian/changelog ===
ardour3 (3.5.403~dfsg-3~ubuntu14.04.1) trusty; urgency=medium

  * No-change backport to trusty (LP: #1450992)

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 03 May 2015 15:03:18 -0500

ardour3 (3.5.403~dfsg-3) unstable; urgency=medium

  * Fix MIDI data loss when editing (Closes: #772118)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 04 Dec 2014 19:34:45 +0100

ardour3 (3.5.403~dfsg-2) unstable; urgency=high

  * Reupload with waf fixes from 3.5.380~dfsg-2 and -3 

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 03 Oct 2014 14:01:07 +0200

ardour3 (3.5.403~dfsg-1) unstable; urgency=high

  * Imported Upstream version 3.5.403~dfsg
  * Critical bugfix release. All users are recommended to upgrade.
  * Details: https://community.ardour.org/node/8457

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 03 Oct 2014 13:02:45 +0200
